#include "StdAfx.h"
#include "WebEventSink.h"


CWebEventSink::CWebEventSink(void)
{
	// this->AddRef();
	m_dwRef = 1;
	// m_lpfnBeforeNavigate2 = NULL;
	// m_lpfnNavigateComplete2 = NULL;
}


CWebEventSink::~CWebEventSink(void)
{
	// this->Release();  
}

STDMETHODIMP CWebEventSink::QueryInterface(REFIID riid,void **ppvObject)
{
	if(IsBadWritePtr(ppvObject,sizeof(void*))) return E_POINTER;

	*ppvObject=NULL;

	if(IsEqualIID(riid,IID_IUnknown) || IsEqualIID(riid,IID_IDispatch) || IsEqualIID(riid,DIID_DWebBrowserEvents2))
	{
		AddRef();
		*ppvObject = this;
		return S_OK;
	}
	else
	{
		return E_NOINTERFACE;
	}
}

STDMETHODIMP_(ULONG) CWebEventSink::AddRef()
{
   InterlockedIncrement(&m_dwRef);
   return m_dwRef;
}

STDMETHODIMP_(ULONG) CWebEventSink::Release()
{
   InterlockedDecrement(&m_dwRef);
   if (m_dwRef == 0)
   {
      delete this;
   }
   return m_dwRef;
}

// We don't need to implement the next three methods because we are just a pure event sink
// We only care about Invoke() which is what IE calls to notify us of events

STDMETHODIMP CWebEventSink::GetTypeInfoCount(UINT *pctinfo)
{
	UNREFERENCED_PARAMETER(pctinfo);
	*pctinfo=0;
	return S_OK;
}

STDMETHODIMP CWebEventSink::GetTypeInfo(UINT iTInfo,LCID lcid,ITypeInfo **ppTInfo)
{
	UNREFERENCED_PARAMETER(iTInfo);
	UNREFERENCED_PARAMETER(lcid);
	UNREFERENCED_PARAMETER(ppTInfo);

	*ppTInfo = NULL;
	return E_NOTIMPL;
}

STDMETHODIMP CWebEventSink::GetIDsOfNames(REFIID riid,LPOLESTR *rgszNames,UINT cNames,LCID lcid,DISPID *rgDispId)
{
	UNREFERENCED_PARAMETER(riid);
	UNREFERENCED_PARAMETER(rgszNames);
	UNREFERENCED_PARAMETER(cNames);
	UNREFERENCED_PARAMETER(lcid);
	UNREFERENCED_PARAMETER(rgDispId);

	return E_NOTIMPL;
}

// This is called by IE to notify us of events
// Full documentation about all the events supported by DWebBrowserEvents2 can be found at
//  http://msdn.microsoft.com/en-us/library/aa768283(VS.85).aspx
STDMETHODIMP CWebEventSink::Invoke(DISPID dispIdMember,REFIID riid,LCID lcid,WORD wFlags,DISPPARAMS *pDispParams,VARIANT *pVarResult,EXCEPINFO *pExcepInfo,UINT *puArgErr)
{
	UNREFERENCED_PARAMETER(lcid);
	UNREFERENCED_PARAMETER(wFlags);
	UNREFERENCED_PARAMETER(pVarResult);
	UNREFERENCED_PARAMETER(pExcepInfo);
	UNREFERENCED_PARAMETER(puArgErr);

	if(!IsEqualIID(riid,IID_NULL)) return DISP_E_UNKNOWNINTERFACE; // riid should always be IID_NULL

	switch (dispIdMember)
	{
		case DISPID_BEFORENAVIGATE2: 
			OnBeforeNavigate2(
				(IDispatch*)pDispParams->rgvarg[6].byref,
				(VARIANT*)pDispParams->rgvarg[5].pvarVal,
				(VARIANT*)pDispParams->rgvarg[4].pvarVal,
				(VARIANT*)pDispParams->rgvarg[3].pvarVal,
				(VARIANT*)pDispParams->rgvarg[2].pvarVal,
				(VARIANT*)pDispParams->rgvarg[1].pvarVal,
				(VARIANT_BOOL*)pDispParams->rgvarg[0].pboolVal
			);
			
			/*BeforeNavigate2(
				(IDispatch*)pDispParams->rgvarg[6].byref,
				(VARIANT*)pDispParams->rgvarg[5].pvarVal,
				(VARIANT*)pDispParams->rgvarg[4].pvarVal,
				(VARIANT*)pDispParams->rgvarg[3].pvarVal,
				(VARIANT*)pDispParams->rgvarg[2].pvarVal,
				(VARIANT*)pDispParams->rgvarg[1].pvarVal,
				(VARIANT_BOOL*)pDispParams->rgvarg[0].pboolVal
			);*/  
			break;
		/*
		case DISPID_NAVIGATECOMPLETE2:
			NavigateComplete2(
				(IDispatch*)pDispParams->rgvarg[0].byref,
				(LPOLESTR)pDispParams->rgvarg[1].pbstrVal
			);
			break;
		*/  
	}

	return S_OK;
}
